# --------------------------------------------------------
#    mmqgis_menu - QGIS plugins menu class
#
#    begin                : August 5, 2009
#    copyright            : (c) 2009 - 2011 by Michael Minn
#    email                : See michaelminn.com
#
#   MMQGIS is free software and is offered without guarantee
#   or warranty. You can redistribute it and/or modify it 
#   under the terms of version 2 of the GNU General Public 
#   License (GPL v2) as published by the Free Software 
#   Foundation (www.gnu.org).
# --------------------------------------------------------

from PyQt4.QtCore import *
from PyQt4.QtGui import *
from qgis.core import *

from mmqgis_dialogs import *

# ---------------------------------------------

class mmqgis_menu:
	def __init__(self, iface):
		self.iface = iface

	def initGui(self):
		icon = QIcon(os.path.dirname(__file__) + "/icons/mmqgis_attribute_export.png")
		self.attribute_export_action = QAction(icon, "Attributes Export to CSV File", self.iface.mainWindow())
		QObject.connect(self.attribute_export_action, SIGNAL("activated()"), self.attribute_export)
		self.iface.addPluginToMenu("&mmqgis", self.attribute_export_action)

		icon = QIcon(os.path.dirname(__file__) + "/icons/mmqgis_attribute_join.png")
		self.attribute_join_action = QAction(icon, "Attributes Join from CSV File", self.iface.mainWindow())
		QObject.connect(self.attribute_join_action, SIGNAL("activated()"), self.attribute_join)
		self.iface.addPluginToMenu("&mmqgis", self.attribute_join_action)

		icon = QIcon(os.path.dirname(__file__) + "/icons/mmqgis_color_map.png")
		self.color_map_action = QAction(icon, "Color Map", self.iface.mainWindow())
		QObject.connect(self.color_map_action, SIGNAL("activated()"), self.color_map)
		self.iface.addPluginToMenu("&mmqgis", self.color_map_action)

		icon = QIcon(os.path.dirname(__file__) + "/icons/mmqgis_grid.png")
		self.grid_action = QAction(icon, "Create Grid Layer", self.iface.mainWindow())
		QObject.connect(self.grid_action, SIGNAL("activated()"), self.grid)
		self.iface.addPluginToMenu("&mmqgis", self.grid_action)

		icon = QIcon(os.path.dirname(__file__) + "/icons/mmqgis_label.png")
		self.label_action = QAction(icon, "Create Label Layer", self.iface.mainWindow())
		QObject.connect(self.label_action, SIGNAL("activated()"), self.label)
		self.iface.addPluginToMenu("&mmqgis", self.label_action)

		icon = QIcon(os.path.dirname(__file__) + "/icons/mmqgis_geocode_google.png")
		self.geocode_google_action = QAction(icon, "Geocode with Google", self.iface.mainWindow())
		QObject.connect(self.geocode_google_action, SIGNAL("activated()"), self.geocode_google)
		self.iface.addPluginToMenu("&mmqgis", self.geocode_google_action)

		icon = QIcon(os.path.dirname(__file__) + "/icons/mmqgis_geocode_street_layer.png")
		self.geocode_street_layer_action = QAction(icon, "Geocode from Street Layer", self.iface.mainWindow())
		QObject.connect(self.geocode_street_layer_action, SIGNAL("activated()"), self.geocode_street_layer)
		self.iface.addPluginToMenu("&mmqgis", self.geocode_street_layer_action)

		icon = QIcon(os.path.dirname(__file__) + "/icons/mmqgis_attribute_export.png")
		self.geometry_export_action = QAction(icon, "Geometry Export to CSV File", self.iface.mainWindow())
		QObject.connect(self.geometry_export_action, SIGNAL("activated()"), self.geometry_export)
		self.iface.addPluginToMenu("&mmqgis", self.geometry_export_action)

		icon = QIcon(os.path.dirname(__file__) + "/icons/mmqgis_attribute_join.png")
		self.geometry_import_action = QAction(icon, "Geometry Import from CSV File", self.iface.mainWindow())
		QObject.connect(self.geometry_import_action, SIGNAL("activated()"), self.geometry_import)
		self.iface.addPluginToMenu("&mmqgis", self.geometry_import_action)

		icon = QIcon(os.path.dirname(__file__) + "/icons/mmqgis_gridify.png")
		self.gridify_action = QAction(icon, "Gridify", self.iface.mainWindow())
		QObject.connect(self.gridify_action, SIGNAL("activated()"), self.gridify)
		self.iface.addPluginToMenu("&mmqgis", self.gridify_action)

		icon = QIcon(os.path.dirname(__file__) + "/icons/mmqgis_hub_distance.png")
		self.hub_distance_action = QAction(icon, "Hub Distance", self.iface.mainWindow())
		QObject.connect(self.hub_distance_action, SIGNAL("activated()"), self.hub_distance)
		self.iface.addPluginToMenu("&mmqgis", self.hub_distance_action)

		icon = QIcon(os.path.dirname(__file__) + "/icons/mmqgis_merge.png")
		self.merge_action = QAction(icon, "Merge Layers", self.iface.mainWindow())
		QObject.connect(self.merge_action, SIGNAL("activated()"), self.merge)
		self.iface.addPluginToMenu("&mmqgis", self.merge_action)

		icon = QIcon(os.path.dirname(__file__) + "/icons/mmqgis_select.png")
		self.select_action = QAction(icon, "Select", self.iface.mainWindow())
		QObject.connect(self.select_action, SIGNAL("activated()"), self.select)
		self.iface.addPluginToMenu("&mmqgis", self.select_action)

		icon = QIcon(os.path.dirname(__file__) + "/icons/mmqgis_sort.png")
		self.sort_action = QAction(icon, "Sort", self.iface.mainWindow())
		QObject.connect(self.sort_action, SIGNAL("activated()"), self.sort)
		self.iface.addPluginToMenu("&mmqgis", self.sort_action)

		icon = QIcon(os.path.dirname(__file__) + "/icons/mmqgis_text_to_float.png")
		self.text_to_float_action = QAction(icon, "Text to Float", self.iface.mainWindow())
		QObject.connect(self.text_to_float_action, SIGNAL("activated()"), self.text_to_float)
		self.iface.addPluginToMenu("&mmqgis", self.text_to_float_action)

		icon = QIcon(os.path.dirname(__file__) + "/icons/mmqgis_voronoi.png")
		self.voronoi_action = QAction(icon, "Voronoi Diagram", self.iface.mainWindow())
		QObject.connect(self.voronoi_action, SIGNAL("activated()"), self.voronoi)
		self.iface.addPluginToMenu("&mmqgis", self.voronoi_action)

	def unload(self):
		self.iface.removePluginMenu("&mmqgis", self.attribute_export_action)
		self.iface.removePluginMenu("&mmqgis", self.attribute_join_action)
		self.iface.removePluginMenu("&mmqgis", self.color_map_action)
		self.iface.removePluginMenu("&mmqgis", self.grid_action)
		self.iface.removePluginMenu("&mmqgis", self.label_action)
		self.iface.removePluginMenu("&mmqgis", self.geocode_google_action)
		self.iface.removePluginMenu("&mmqgis", self.geocode_street_layer_action)
		self.iface.removePluginMenu("&mmqgis", self.geometry_export_action)
		self.iface.removePluginMenu("&mmqgis", self.geometry_import_action)
		self.iface.removePluginMenu("&mmqgis", self.gridify_action)
		self.iface.removePluginMenu("&mmqgis", self.hub_distance_action)
		self.iface.removePluginMenu("&mmqgis", self.merge_action)
		self.iface.removePluginMenu("&mmqgis", self.select_action)
		self.iface.removePluginMenu("&mmqgis", self.sort_action)
		self.iface.removePluginMenu("&mmqgis", self.text_to_float_action)
		self.iface.removePluginMenu("&mmqgis", self.voronoi_action)

	def attribute_export(self):
		dialog = mmqgis_attribute_export_dialog(self.iface)
		dialog.exec_()

	def attribute_join(self):
		dialog = mmqgis_attribute_join_dialog(self.iface)
		dialog.exec_()

	def color_map(self):
		dialog = mmqgis_color_map_dialog(self.iface)
		dialog.exec_()

	def geocode_google(self):
		dialog = mmqgis_geocode_google_dialog(self.iface)
		dialog.exec_()

	def geometry_export(self):
		dialog = mmqgis_geometry_export_dialog(self.iface)
		dialog.exec_()

	def geometry_import(self):
		dialog = mmqgis_geometry_import_dialog(self.iface)
		dialog.exec_()

	def grid(self):
		dialog = mmqgis_grid_dialog(self.iface)
		dialog.exec_()

	def gridify(self):
		dialog = mmqgis_gridify_dialog(self.iface)
		dialog.exec_()

	def hub_distance(self):
		dialog = mmqgis_hub_distance_dialog(self.iface)
		dialog.exec_()

	def label(self):
		dialog = mmqgis_label_dialog(self.iface)
		dialog.exec_()

	def merge(self):
		dialog = mmqgis_merge_dialog(self.iface)
		dialog.exec_()

	def select(self):
		dialog = mmqgis_select_dialog(self.iface)
		dialog.exec_()

	def sort(self):
		dialog = mmqgis_sort_dialog(self.iface)
		dialog.exec_()

	def geocode_street_layer(self):
		dialog = mmqgis_geocode_street_layer_dialog(self.iface)
		dialog.exec_()

	def text_to_float(self):
		dialog = mmqgis_text_to_float_dialog(self.iface)
		dialog.exec_()

	def voronoi(self):
		dialog = mmqgis_voronoi_dialog(self.iface)
		dialog.exec_()

